<?php
namespace Claromentis\Core\User\Directory;

$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("op" . "ti" . "on" . "s" => base64_decode("b3B0" . "aW9u" . "cw=="), "_87da279507cfe998" . "29e40eca558cf7d1" => base64_decode("IGRvZXNuJ3QgZXhpc3QgLSBjYW4nd" . "CB1cGRhdGU="), "_3bc8ccbfa87d" . "de178330887ee" . "ef2fc5e" => base64_decode("RGlyZWN0" . "b3J5IHdp" . "dGggaWQg"), "t" . "y" . "p" . "e" => base64_decode("dHlw" . "ZQ=="), "_99cee2d2272a8550" . "f4b21e3cb57fff7d" => base64_decode("ZW5hYmxlZ" . "A=="), "_7f628626dd1d55c71b1fc0" . "932ffd1d2c" => base64_decode("aXNfYXJyY" . "Xk="), "_d1d997d6b7fdc02cc83b4b" . "996482c63a" => base64_decode("MA" . "=="));
use Claromentis\Core\Config\Config;
use Claromentis\Core\User\Directory\Exception\UnknownDirectoryException;




class DirectoriesList
{
    protected Config $storage;
    protected string $variable_name;
    public function __construct(Config $storage, $_af1ebf352fcd1d2906ecd42ae1cde56e)
    {
        $this->storage = $storage;
        $this->variable_name = $_af1ebf352fcd1d2906ecd42ae1cde56e;
    }
    
    
    
    
    public function GetAll() : array
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->storage->get($this->variable_name);
        return $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_7f62862" . "6dd1d55c" . "71b1fc09" . "32ffd1d2" . "c"]($_1ac0335a1f605e216d9ffde5545a81e3) ? $_1ac0335a1f605e216d9ffde5545a81e3 : [];
    }
    
    
    
    
    
    
    
    
    
    public function GetAllEnabled() : array
    {
        $_d00c9bfa132c9b19f21346632ca3484c = [];
        $_4a1e36876b85dbb4c5d96e6d097ab404 = $this->GetAll();
        foreach ($_4a1e36876b85dbb4c5d96e6d097ab404 as $_40421a4e75c2ba3c82b018e6b56f7425 => $_d9dec3fec40d714836246e2dbbaa7deb) {
            if ($_40421a4e75c2ba3c82b018e6b56f7425 != $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_d1d997d6b7fdc02cc83b4b996482c" . "63a"]) {
                
                
                if ($_d9dec3fec40d714836246e2dbbaa7deb[$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["opti" . "ons"]][$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_99cee2d2272a8550f4b21e3cb57fff" . "7d"]]) {
                    
                    
                    $_d00c9bfa132c9b19f21346632ca3484c[$_40421a4e75c2ba3c82b018e6b56f7425] = $_d9dec3fec40d714836246e2dbbaa7deb;
                }
            }
        }
        return $_d00c9bfa132c9b19f21346632ca3484c;
    }
    
    
    
    
    
    
    
    public function Add(string $type, array $options) : string
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        $key = \CryptUtils::GetRandomString(20);
        $_1ac0335a1f605e216d9ffde5545a81e3[$key] = [$GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["typ" . "e"] => $type, $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["opt" . "ion" . "s"] => $options];
        $this->SaveAll($_1ac0335a1f605e216d9ffde5545a81e3);
        return $key;
    }
    public function GetByKey(string $key) : ?array
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        return isset($_1ac0335a1f605e216d9ffde5545a81e3[$key]) ? $_1ac0335a1f605e216d9ffde5545a81e3[$key] : null;
    }
    
    
    
    
    
    
    
    public function Update(string $key, array $options)
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        if (!isset($_1ac0335a1f605e216d9ffde5545a81e3[$key])) {
            throw new UnknownDirectoryException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_3bc8ccbfa87dde178330887eee" . "f2fc5e"] . $key . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_87da279507cfe9982" . "9e40eca558cf7d1"]);
        }
        $_1ac0335a1f605e216d9ffde5545a81e3[$key][$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["opti" . "ons"]] = $options;
        $this->SaveAll($_1ac0335a1f605e216d9ffde5545a81e3);
    }
    public function Delete(string $key)
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        if (!isset($_1ac0335a1f605e216d9ffde5545a81e3[$key])) {
            return;
        }
        unset($_1ac0335a1f605e216d9ffde5545a81e3[$key]);
        $this->SaveAll($_1ac0335a1f605e216d9ffde5545a81e3);
    }
    protected function SaveAll(array $_1ac0335a1f605e216d9ffde5545a81e3)
    {
        $this->storage->set($this->variable_name, $_1ac0335a1f605e216d9ffde5545a81e3);
        $this->storage->save();
    }
    
    
    
    
    public function DirectoriesAreInUse() : bool
    {
        return !empty($this->GetAllEnabled());
    }
}